#define DS_MAX_NUMBER_STRING_REPRESENTATION_CHARS	16

size_t dsStringVCalculateRequiredSize(const char *s, va_list ap) {
    int args = 0;
    const char *arg;
    size_t i, size;

    va_list apc;
    const char *req;

    ds_assert_zero(s);
    
    va_copy(apc, ap);

    size = strlen(s) + 1;
    for (req = strchr(s, '%'); req; ) {
	if (req != s) {
	    if ((*(req-1))=='%') {
		req = dsStringStrchr(req + 1, '%');
		continue;
	    }
/* Seems not treated that way
	    for (i=0; ((req != s+i)&&((*(req-i-1))=='\\')); i++);
	    if (i%2) {
		req = dsStringStrchr(req + 1, '%');
		continue;
	    }
*/
	}
	
	for (i=1; !(((req[i]<='z')&&(req[i]>='a'))||((req[i]<='Z')&&(req[i]>='A'))); i++);
//	while ((req[i]=='l')||(req[i]=='L')||(req[i]=='h')||(req[i]=='H')||(req[i]=='q')||(req[i]=='Q')||(req[i]=='j')||(req[i]=='J')||(req[i]=='z')||(req[i]=='Z')||(req[i]=='t')||(req[i]=='T')) i++;
//	if ((req[i]=='s')||(req[i]=='S'))

	if (req[i]=='l') i++;
	if (req[i]=='s') {
	    arg = va_arg(apc, const char*);
	    size += strlen(arg);
	} else {
	    va_arg(apc, void);
	    size += DS_MAX_NUMBER_STRING_REPRESENTATION_CHARS;
	}
	
	args++;
	req = dsStringStrchr(req + i + 1, '%');
    }

    va_end(apc);
    
    return size;
}

size_t dsStringCalculateRequiredSize(const char *s, ...) {
    size_t res;
    va_list ap;

    ds_assert_zero(s);
    
    va_start(ap, s);
    res = dsStringVCalculateRequiredSize(s, ap);
    va_end(ap);
    
    return res;
}

DSString dsStringVCreate(DSMallocContext mctx, const char *s, va_list ap) {
    int size, rsize;
    DSString res, newres;
    va_list apc;

    ds_assert_null(s);

    size = dsStringVCalculateRequiredSize(s, ap);
    res = (char*)dsMalloc(mctx, size*sizeof(char));
    if (!res) return NULL;

    va_copy(apc, ap);
    vsprintf(res,s,apc);
    va_end(apc);

    return res;
}
