#ifndef _OPC_DATA_REPRESENTATION_H
#define _OPC_DATA_REPRESENTATION_H

#include <opcformat.h>
#include <opcallocator.h>

typedef struct OPCDataRepresentationContextT *OPCDataRepresentationContext;

#include <opcdatachunk.h>

struct OPCDataRepresentationContextT {
    OPCMallocContext malloc;
    OPCAllocatorContext allocator;
    OPCFormatContext format;
    OPCDataRepresentationContext base;
    OPCType type;
    unsigned long id;
};


OPCDataRepresentationContext opcDataRepresentationCreateContext(OPCMallocContext mctx);
int opcDataRepresentationInitContext(OPCDataRepresentationContext ctx, OPCFormatContext format, OPCType type, OPCAllocatorContext allocator);
void opcDataRepresentationFreeContext(OPCDataRepresentationContext ctx);
void opcDataRepresentationDestroyContext(OPCDataRepresentationContext ctx);

int  opcDataRepresentationSetId(OPCDataRepresentationContext ctx, unsigned short int id);
int opcDataRepresentationSetBaseRepresentation(OPCDataRepresentationContext ctx, OPCDataRepresentationContext base);

int opcDataRepresentationImportData(OPCDataRepresentationContext ctx, OPCDataChunkContext chunk, const void *data, unsigned long size);
int opcDataRepresentationGet(OPCDataRepresentationContext ctx, OPCDataChunkContext chunk);

void opcDataRepresentationClear(OPCDataRepresentationContext ctx, OPCData data);

#endif /* _OPC_DATA_REPRESENTATION_H */
