#ifndef _OPC_ERROR_H
#define _OPC_ERROR_H

#include <dserror.h>

int opcErrorInit();
void opcErrorDestroy();

#ifdef _OPC_ERROR_C
static DSErrorS opc_errors[] = {
	{0x1001, opc_string("OPC_ERR_CREATE")},
	{0x1100, opc_string("OPC_ERR_INTERFACE")},
	{0x1110, opc_string("OPC_ERR_INTERFACE_GET_SERVERTREE")},
	{0x1111, opc_string("OPC_ERR_INTERFACE_GET_CONFIGURATION")},
	{0x1110, opc_string("OPC_ERR_SERVERINTERFACE")},
	{0x1120, opc_string("OPC_ERR_STATE")},
	{0x1121, opc_string("OPC_ERR_STATE_CREATE")},
	{0x1122, opc_string("OPC_ERR_STATE_INVALID_STATE")},
	{0x1150, opc_string("OPC_ERR_SERVERTREE")},
	{0x1151, opc_string("OPC_ERR_SERVERTREE_CREATE")},
	{0x1153, opc_string("OPC_ERR_SERVERTREE_ALREADY_REGISTERED")},
	{0x1154, opc_string("OPC_ERR_SERVERTREE_CREATE_PATH")},
	{0x1155, opc_string("OPC_ERR_SERVERTREE_ITEM_HAVE_MANUAL_CHILDS")},
	{0x1156, opc_string("OPC_ERR_SERVERTREE_ITEM_NOTFOUND")},
	{0x1157, opc_string("OPC_ERR_SERVERTREE_ITEM_NOTLINKED")},
	{0x1160, opc_string("OPC_ERR_ITEM")},
	{0x1161, opc_string("OPC_ERR_ITEM_CREATE")},
	{0x1162, opc_string("OPC_ERR_ITEM_FILTERED")},
	{0x1163, opc_string("OPC_ERR_ITEM_NOTCONNECTED")},
	{0x1164, opc_string("OPC_ERR_ITEM_OUTOFDATE")},
	{0x1165, opc_string("OPC_ERR_ITEM_OUTOFDATE_REACQUIRING")},
	{0x1200, opc_string("OPC_ERR_FORMATS")},
	{0x1201, opc_string("OPC_ERR_FORMATS_CREATE")},
	{0x1202, opc_string("OPC_ERR_FORMATS_INCOMPLETE")},
	{0x1205, opc_string("OPC_ERR_FORMATS_REGISTER")},
	{0x1206, opc_string("OPC_ERR_FORMATS_REGISTER_NATIVE")},
	{0x1207, opc_string("OPC_ERR_FORMATS_REGISTER_OPCXML")},
	{0x1208, opc_string("OPC_ERR_FORMATS_REGISTER_ALREADY_REGISTERED")},
	{0x1209, opc_string("OPC_ERR_FORMATS_MISSING")},
	{0x120A, opc_string("OPC_ERR_FORMATS_MISSING_NATIVE")},
	{0x120B, opc_string("OPC_ERR_FORMATS_MISSING_OPCXML")},
	{0x1210, opc_string("OPC_ERR_FORMAT")},
	{0x1211, opc_string("OPC_ERR_FORMAT_CREATE")},
	{0x1212, opc_string("OPC_ERR_FORMAT_INCOMPLETE")},
	{0x1213, opc_string("OPC_ERR_FORMAT_MISSING_METHOD_SEND")},
	{0x1214, opc_string("OPC_ERR_FORMAT_MISSING_METHOD_IMPORTDATA")},
	{0x1215, opc_string("OPC_ERR_FORMAT_MISSING_METHOD_READNATIVE")},
	{0x1216, opc_string("OPC_ERR_FORMAT_MISSING_METHOD_WRITENATIVE")},
	{0x1221, opc_string("OPC_ERR_FD_OPCBINARY")},
	{0x1222, opc_string("OPC_ERR_FD_OPCBINARY_CREATE")},
	{0x1223, opc_string("OPC_ERR_FD_OPCBINARY_PARSE")},
	{0x1224, opc_string("OPC_ERR_FD_OPCBINARY_VALIDATE")},
	{0x1230, opc_string("OPC_ERR_FD_OPCBINARY_DICTIONARY")},
	{0x1231, opc_string("OPC_ERR_FD_OPCBINARY_DICTIONARY_CREATE")},
	{0x1232, opc_string("OPC_ERR_FD_OPCBINARY_DICTIONARY_FIND")},
	{0x1233, opc_string("OPC_ERR_FD_OPCBINARY_DICTIONARY_INVALID_ENDIANESS")},
	{0x1234, opc_string("OPC_ERR_FD_OPCBINARY_DICTIONARY_INVALID_FLOATINGFORMAT")},
	{0x1240, opc_string("OPC_ERR_FORMAT_NATIVE")},
	{0x1241, opc_string("OPC_ERR_FORMAT_NATIVE_CREATE")},
	{0x1243, opc_string("OPC_ERR_FORMAT_NATIVE_TYPE_NOTIMPLEMENTED")},
	{0x1250, opc_string("OPC_ERR_FORMAT_BINARY")},
	{0x1251, opc_string("OPC_ERR_FORMAT_BINARY_CREATE")},
	{0x1253, opc_string("OPC_ERR_FORMAT_BINARY_TYPE_NOTIMPLEMENTED")},
	{0x1270, opc_string("OPC_ERR_FORMAT_OPCXML")},
	{0x1271, opc_string("OPC_ERR_FORMAT_OPCXML_CREATE")},
	{0x1273, opc_string("OPC_ERR_FORMAT_OPCXML_TYPE_NOTIMPLEMENTED")},
	{0x1290, opc_string("OPC_ERR_FORMAT_XML")},
	{0x1291, opc_string("OPC_ERR_FORMAT_XML_CREATE")},
	{0x1293, opc_string("OPC_ERR_FORMAT_TYPE_NOTIMPLEMENTED")},
	{0x1300, opc_string("OPC_ERR_TYPE")},
	{0x1301, opc_string("OPC_ERR_TYPE_CREATE")},
	{0x1302, opc_string("OPC_ERR_TYPE_NOTIMPLEMENTED")},
	{0x1303, opc_string("OPC_ERR_TYPE_NOTSUPPORTED_BY_FORMAT")},
	{0x1304, opc_string("OPC_ERR_TYPE_INVALID_SIZE")},
	{0x1305, opc_string("OPC_ERR_TYPE_STANDARD")},
	{0x1306, opc_string("OPC_ERR_TYPE_STANDARD_CREATE")},
	{0x1310, opc_string("OPC_ERR_FORMAT_OPCXML_INTEGER_READ")},
	{0x1311, opc_string("OPC_ERR_FORMAT_OPCXML_INTEGER_READ_OPTION_NOTIMPLEMENTED")},
	{0x1315, opc_string("OPC_ERR_FORMAT_OPCXML_INTEGER_WRITE")},
	{0x1316, opc_string("OPC_ERR_FORMAT_OPCXML_INTEGER_WRITE_OPTION_NOTIMPLEMENTED")},
	{0x1320, opc_string("OPC_ERR_FORMAT_OPCXML_FLOAT_READ")},
	{0x1321, opc_string("OPC_ERR_FORMAT_OPCXML_FLOAT_READ_OPTION_NOTIMPLEMENTED")},
	{0x1325, opc_string("OPC_ERR_FORMAT_OPCXML_FLOAT_WRITE")},
	{0x1326, opc_string("OPC_ERR_FORMAT_OPCXML_FLOAT_WRITE_OPTION_NOTIMPLEMENTED")},
	{0x1400, opc_string("OPC_ERR_DATAMANAGER")},
	{0x1401, opc_string("OPC_ERR_DATAMANAGER_CREATE")},
	{0x1402, opc_string("OPC_ERR_DATAMANAGER_CREATE_DATAFAST_MANAGER")},
	{0x1403, opc_string("OPC_ERR_DATAMANAGER_CREATE_DATA_MANAGER")},
	{0x1404, opc_string("OPC_ERR_DATAMANAGER_REPRESENTATION_ALREADY_REGISTERED")},
	{0x1410, opc_string("OPC_ERR_DATAFAST")},
	{0x1411, opc_string("OPC_ERR_DATAFAST_CREATE")},
	{0x1412, opc_string("OPC_ERR_DATAFAST_ALLOCATOR_BUSY")},
	{0x1420, opc_string("OPC_ERR_DATA")},
	{0x1421, opc_string("OPC_ERR_DATA_CREATE")},
	{0x1430, opc_string("OPC_ERR_CHUNKPOOL")},
	{0x1431, opc_string("OPC_ERR_CHUNKPOOL_CREATE")},
	{0x1432, opc_string("OPC_ERR_CHUNKPOOL_GET")},
	{0x1436, opc_string("OPC_ERR_DATACHUNK")},
	{0x1437, opc_string("OPC_ERR_DATACHUNK_CREATE")},
	{0x1440, opc_string("OPC_ERR_REPRESENTATION")},
	{0x1441, opc_string("OPC_ERR_REPRESENTATION_CREATE")},
	{0x1442, opc_string("OPC_ERR_REPRESENTATION_CREATE_NATIVE")},
	{0x1443, opc_string("OPC_ERR_REPRESENTATION_CREATE_OPCXML")},
	{0x1444, opc_string("OPC_ERR_REPRESENTATION_MISSING")},
	{0x1445, opc_string("OPC_ERR_REPRESENTATION_MISSING_NATIVE")},
	{0x1446, opc_string("OPC_ERR_REPRESENTATION_MISSING_OPCXML")},
	{0x1447, opc_string("OPC_ERR_REPRESENTATION_INCOMPLETE")},
	{0x144A, opc_string("OPC_ERR_REPRESENTATION_DISABLED")},
	{0x1450, opc_string("OPC_ERR_DATAREPRESENTATION")},
	{0x1451, opc_string("OPC_ERR_DATAREPRESENTATION_CREATE")},
	{0x1452, opc_string("OPC_ERR_DATAREPRESENTATION_INCOMPLETE")},
	{0x1453, opc_string("OPC_ERR_DATAREPRESENTATION_OPTIONS")},
	{0x1454, opc_string("OPC_ERR_DATAREPRESENTATION_OPTIONS_INCOMPLETE")},
	{0x1455, opc_string("OPC_ERR_DATAREPRESENTATION_ALLOCATOR_NOTSUPPOPRTED")},
	{0x1456, opc_string("OPC_ERR_DATAREPRESENTATION_CONVERT_NOTSUPPORTED")},
	{0x1500, opc_string("OPC_ERR_PROPERTIES")},
	{0x1501, opc_string("OPC_ERR_PROPERTIES_CREATE")},
	{0x1502, opc_string("OPC_ERR_PROPERTIES_INVALID_PROPERTY")},
	{0x1503, opc_string("OPC_ERR_PROPERTIES_ALREADY_REGISTERED")},
	{0x1504, opc_string("OPC_ERR_PROPERTIES_ID_USED")},
	{0x1505, opc_string("OPC_ERR_PROPERTIES_LIMIT_EXCEEDED")},
	{0x1510, opc_string("OPC_ERR_PROPERTY")},
	{0x1511, opc_string("OPC_ERR_PROPERTY_CREATE")},
	{0x1600, opc_string("OPC_ERR_FRONTEND")},
	{0x1601, opc_string("OPC_ERR_FRONTEND_CREATE")},
	{0x1602, opc_string("OPC_ERR_FRONTEND_REQUEST")},
	{0x1603, opc_string("OPC_ERR_FRONTEND_REQUEST_CREATE")},
	{0x1604, opc_string("OPC_ERR_FRRONTED_REQUEST_INVALID")},
	{0x1610, opc_string("OPC_ERR_XLIB")},
	{0x1611, opc_string("OPC_ERR_XLIB_CREATE")},
	{0x1612, opc_string("OPC_ERR_XLIB_COMMANDS_INIT")},
	{0x1613, opc_string("OPC_ERR_XLIB_INVALID_SCHEMA")},
	{0x1614, opc_string("OPC_ERR_XLIB_PARSER_CREATE")},
	{0x1650, opc_string("OPC_ERR_XLIB_REQUEST")},
	{0x1651, opc_string("OPC_ERR_XLIB_REQUEST_CREATE")},
	{0x1652, opc_string("OPC_ERR_XLIB_REQUEST_INVALID")},
	{0x1653, opc_string("OPC_ERR_XLIB_REQUEST_PARSE")},
	{0x1654, opc_string("OPC_ERR_XLIB_REQUEST_PARSE_CHUNK_TO_SMALL")},
	{0x1660, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE")},
	{0x1661, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_EMPTY")},
	{0x1662, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_NS")},
	{0x1681, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_ITEMNAME")},
	{0x1670, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS")},
	{0x1671, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_UNKNOWN_REQUEST")},
	{0x1672, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_UNSUPPORTED_REQUEST")},
	{0x1673, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_INVALID_REQUEST")},
	{0x1675, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_MORE_ITEMS")},
	{0x1676, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_NOMORE_ITEMS")},
	{0x1680, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_ITEM")},
	{0x1682, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_ITEM_NOTFOUND")},
	{0x1690, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE")},
	{0x1691, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_BROWSE_FILTER")},
	{0x1692, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_VENDOR_FILTER")},
	{0x1693, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_NAME_FILTER")},
	{0x1694, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_RETURNED_ELEMENTS_NUMBER")},
	{0x16A0, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT")},
	{0x16A1, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID")},
	{0x16A2, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_TIMEDOUT")},
	{0x16A3, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_BROWSE_FILTER")},
	{0x16A4, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_VENDOR_FILTER")},
	{0x16A5, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_NAME_FILTER")},
	{0x16A6, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_ITEMNAME")},
	{0x16F0, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE")},
	{0x16F1, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE_START")},
	{0x16F2, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE_FINISH")}
};
#define opc_errors_number 155
#endif /* _OPC_ERROR_C */

#endif /* _OPC_ERROR_H */
