#include <dslib.h>
#include <dsassert.h>
#include <dsdebug.h>

#include <opcitemproperties.h>

void opcItemPropertiesZeroContext(OPCItemPropertiesContext ctx) {
    ds_assert_return(ctx);
    
    ctx->properties=NULL;
    ctx->relocation=NULL;
}

OPCItemPropertiesContext opcItemPropertiesCreateContext(DSMallocContext mctx) {
    OPCItemPropertiesContext ctx;

    dsDebugServer(DS_DEBUG_DEBUG, "opcItemPropertiesCreateContext");    

    ctx = (OPCItemPropertiesContext)dsMalloc(mctx,sizeof(struct OPCItemPropertiesContextT));
    if (ctx) {
	ctx->malloc=mctx;
	opcItemPropertiesZeroContext(ctx);
	
    }
    return ctx;
}

int opcItemPropertiesInitContext(OPCItemPropertiesContext ctx, unsigned short properties_maxid) {
    unsigned short i;
    
    ds_assert_param(ctx);
    
    ctx->properties = (OPCItemPropertyContext*)dsMalloc(ctx->malloc, properties_maxid*sizeof(OPCItemPropertyContext));
    if (!ctx->properties) return DS_ERR_MEM;
    
    for (i=0;i<properties_maxid;i++)
	ctx->properties[i]=NULL;

    return 0;
}

int opcItemPropertiesInitLimitedContext(OPCItemPropertiesContext ctx, unsigned short size, unsigned short *relocation) {
    ds_assert_param(ctx);
    
    ctx->relocations = size;
    ctx->relocation = relocation;
    
    return opcItemPropertiesInitContext(ctx, size);
}

void opcItemPropertiesFreeContext(OPCItemPropertiesContext ctx) {
    dsDebugServer(DS_DEBUG_NOTICE, "opcItemPropertiesFreeContext");    

    ds_assert_return(ctx);

    if (ctx->properties) dsFree(ctx->malloc, ctx->properties);
    opcItemPropertiesZeroContext(ctx);
}

void opcItemPropertiesDestroyContext(OPCItemPropertiesContext ctx) {
    dsDebugServer(DS_DEBUG_NOTICE, "opcItemPropertiesDestroyContext");    

    opcItemPropertiesFreeContext(ctx);
    dsFree(ctx->malloc,ctx);
}

/*
OPCPropertyContext opcItemPropertiesCreateProperty(OPCItemPropertiesContext ctx, OPCPropertyContext prop) {
}

opcItemPropertiesDestroyProperty(OPCItemPropertiesContext ctx, OPCItemPropertyContext iprop) {
}

*/
