#define _OPC_FORMAT_NATIVE_C
#include <dsassert.h>
#include <dsdebug.h>

#include <dslib.h>

#include <opcformatnative.h>

OPCFormatContext opcFormatNative() {
    return (OPCFormatContext)&opc_format_native;
}

/*
OPCFormatContext opcFormatNativeCreateContext(DSMallocContext mctx) {
    OPCFormatContext ctx;

    ctx = (OPCFormatContext)dsMalloc(mctx,sizeof(struct OPCFormatNativeContextT));
    if (ctx) {
	memcpy(ctx,&opc_format_native,sizeof(opc_format_native));
	ctx->malloc=mctx;
    }
    return ctx;
}


static inline void opcFormatNativeInstanceZeroContext(OPCFormatNativeInstanceContext ctx) {
    ds_assert_null(ctx);
    
    ctx->data = NULL;
}

OPCFormatInstanceContext opcFormatNativeInstanceCreateContext(OPCFormatContext format) {
    OPCFormatInstanceContext ctx;
    
    ds_assert_null(format);

    ctx = (OPCFormatInstanceContext)dsMalloc(format->malloc,sizeof(struct OPCFormatNativeInstanceContextT));
    if (ctx) {
	ctx->malloc=format->malloc;
	ctx->format=format;
	opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);
    }
    return ctx;
}

int opcFormatNativeInstanceInitContext(OPCFormatInstanceContext ctx, const OPCFormatNativeOptionsContext options) {
    int err;
    unsigned long buffer_initial_size; 
    
//    OPCFormatNativeInstanceContext fi = (OPCFormatNativeInstanceContext)ctx;
    DSDataBufferContext data;
    
    ds_assert_param(ctx);
    
    opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);

    data = dsDataBufferCreateContext(ctx->malloc);
    if (!data) return OPC_ERR_DATA_BUFFER_CREATE;
    
    if (options) buffer_initial_size = options->buffer_initial_size;
    else buffer_initial_size = 0;
    
    err = dsDataBufferInitContext(data, ctx->format->buffer_pool, buffer_initial_size);
    if (err) {
	dsDataBufferDestroyContext(data);
	return err;
    }
    
    ((OPCFormatNativeInstanceContext)ctx)->data = data;
    
    return 0;
}

void opcFormatNativeInstanceFreeContext(OPCFormatInstanceContext ctx) {
    ds_assert_return(ctx);

    if (((OPCFormatNativeInstanceContext)ctx)->data) 
	dsDataBufferDestroyContext(((OPCFormatNativeInstanceContext)ctx)->data);
	
    opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);
}

void opcFormatNativeInstanceDestroyContext(OPCFormatInstanceContext ctx) {
    opcFormatNativeInstanceFreeContext(ctx);
    ds_assert_return(ctx->format);
    dsFree(ctx->format->malloc, ctx);
}

*/

int opcFormatNativeImportData(OPCFormatNativeContext ctx, OPCType type, DSAllocatorContext allocator, OPCData data, const void *buffer, unsigned long size) {
    DSAllocation allocation;
    void *ptr;
    
    ds_assert_param(ctx);
    ds_assert_param(type);
    ds_assert_param(data);
    ds_assert_param(buffer);
    ds_assert_param(allocator);

    if ((!size)&&(type->size)) size=type->size;

    if (size) {
	allocation = dsAllocatorSimpleAllocate(allocator, size);
	if (allocation) ptr = dsAllocatorGet(allocator, allocation, NULL);
	else return DS_ERR_ALLOCATOR_ALLOCATE;
//	dsDebugServer(DS_DEBUG_WARNING, "MEMCPY: %p - %p (%lu)", ptr, ptr + size, size);
	memcpy(ptr, buffer, size);
	data->data=(void*)allocation;
	data->size = dsAllocatorSizeof(allocator, allocation, 1);
	data->type = OPC_DATA_TYPE_ALLOCATION;
	return 0;
    } else {
	// ToDo: go by items
    }
    return DS_ERR_NOTIMPLEMENTED;
}
