#ifndef _OPC_CHUNK_POOL
#define _OPC_CHUNK_POOL

#include <dsmalloc.h>
#include <dslock.h>
#include <opcdatachunk.h>

typedef struct OPCChunkPoolContextT *OPCChunkPoolContext;

struct OPCChunkPoolContextT {
    DSMallocContext malloc;
    DSLockContext lock;
    
    unsigned char bins;    
    OPCDataChunkContext *first_chunk;
    OPCDataChunkContext *last_chunk;
};

OPCChunkPoolContext opcChunkPoolCreateContext(DSMallocContext mctx);
int opcChunkPoolInitContext(OPCChunkPoolContext ctx, unsigned char bins);
void opcChunkPoolFreeContext(OPCChunkPoolContext ctx);
void opcChunkPoolDestroyContext(OPCChunkPoolContext ctx);

OPCDataChunkContext opcChunkPoolGetChunk(OPCChunkPoolContext ctx, OPCRepresentationInfo *definfo, unsigned short int formats);
void opcChunkPoolReturnChunk(OPCChunkPoolContext ctx, OPCDataChunkContext chunk);

#endif /* _OPC_CHUNK_POOL */
