#include <dslib.h>
#include <dsassert.h>

#include <opcrepresentation.h>

void opcRepresentationUnref(OPCRepresentationContext ctx) {
    if (ctx&&ctx->Unref) ctx->Unref(ctx);
}

int opcRepresentationSetId(OPCRepresentationContext ctx, unsigned short int repid) {
    if (!ctx) return DS_ERR_INVALID_ARGUMENT;
    ctx->id = repid;
    return 0;
}

int opcRepresentationDataDataBuffer(OPCRepresentationInfo repinfo, DSDataBufferContext db) { 
    repinfo->ctx = db;
    repinfo->malloc = NULL;
    repinfo->Send = opcUserDataSendDataBuffer;
    repinfo->Destroy = NULL;
    repinfo->destructor_type = OPC_DATA_DESTRUCTOR_RETURN;
    repinfo->Destructor = dsDataBufferFree;
    return 0;
}
